# Ogre::SubMesh Class Reference

Defines a part of a complete mesh. More...

`#include <OgreSubMesh.h>`

List of all members.

## Public Types

typedef std::multimap< size_t, VertexBoneAssignment > | VertexBoneAssignmentList
| Multimap of verex bone assignments (orders by vertex index).
typedef MapIterator< VertexBoneAssignmentList > | BoneAssignmentIterator

## Public Member Functions

| SubMesh ()
| ~SubMesh ()
void | setMaterialName (const String &matName)
| Sets the name of the Material which this SubMesh will use.
const String & | getMaterialName (void) const
bool | isMatInitialised (void) const
| Returns true if a material has been assigned to the submesh, otherwise returns false.
void | _getRenderOperation (RenderOperation &rend, ushort lodIndex=0)
| Returns a RenderOperation structure required to render this mesh.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh.
BoneAssignmentIterator | getBoneAssignmentIterator (void)
| Gets an iterator for access all bone assignments.
void | _compileBoneAssignments (void)
| Must be called once to compile bone assignments into geometry buffer.

## Public Attributes

bool | useSharedVertices
| Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices.
RenderOperation::OperationType | operationType
| The render operation type used to render this submesh.
VertexData * | vertexData
| Dedicated vertex data (only valid if useSharedVertices = false).
IndexData * | indexData
| Face index data.
ProgressiveMesh::LODFaceList | mLodFaceList
Mesh * | parent
| Reference to parent Mesh (not a smart pointer so child does not keep parent alive).

## Protected Member Functions

void | removeLodLevels (void)
| Internal method for removing LOD data.

## Protected Attributes

String | mMaterialName
| Name of the material this SubMesh uses.
bool | mMatInitialised
| Is there a material yet?
VertexBoneAssignmentList | mBoneAssignments
bool | mBoneAssignmentsOutOfDate
| Flag indicating that bone assignments need to be recompiled.

## Friends

class | Mesh
class | MeshSerializerImpl
class | MeshSerializerImpl_v1_2
class | MeshSerializerImpl_v1_1

## Detailed Description

Defines a part of a complete mesh.

Remarks:
  Meshes which make up the definition of a discrete 3D object are made up of potentially multiple parts. This is because different parts of the mesh may use different materials or use different vertex formats, such that a rendering state change is required between them.

  Like the Mesh class, instatiations of 3D objects in the scene share the SubMesh instances, and have the option of overriding their material differences on a per-object basis if required. See the SubEntity class for more information.

Definition at line 51 of file OgreSubMesh.h.

## Member Typedef Documentation

typedef MapIterator<VertexBoneAssignmentList> Ogre::SubMesh::BoneAssignmentIterator

| Definition at line 124 of file OgreSubMesh.h.

typedef std::multimap<size_t, VertexBoneAssignment> Ogre::SubMesh::VertexBoneAssignmentList

| Multimap of verex bone assignments (orders by vertex index). Definition at line 123 of file OgreSubMesh.h.

## Constructor & Destructor Documentation

Ogre::SubMesh::SubMesh | ( |  | ) |

Ogre::SubMesh::~SubMesh | ( |  | ) |

## Member Function Documentation

void Ogre::SubMesh::_compileBoneAssignments | ( | void |  | ) |

| Must be called once to compile bone assignments into geometry buffer.

void Ogre::SubMesh::_getRenderOperation | ( | RenderOperation & | rend,
|  | ushort | lodIndex = 0
| ) |

Returns a RenderOperation structure required to render this mesh.

Parameters:

  rend | Reference to a RenderOperation structure to populate.
  lodIndex | The index of the LOD to use.

void Ogre::SubMesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks:
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the dedicated geometry of the SubMesh. To assign weights to the shared Mesh geometry, see the equivalent methods on Mesh.

void Ogre::SubMesh::clearBoneAssignments | ( | void |  | ) |

Removes all bone assignments for this mesh.

  This method is for assigning weights to the dedicated geometry of the SubMesh. To assign weights to the shared Mesh geometry, see the equivalent methods on Mesh.

BoneAssignmentIterator Ogre::SubMesh::getBoneAssignmentIterator | ( | void |  | ) |

Gets an iterator for access all bone assignments.

Remarks:
  Only valid if this SubMesh has dedicated geometry.

const String& Ogre::SubMesh::getMaterialName | ( | void |  | ) | const

bool Ogre::SubMesh::isMatInitialised | ( | void |  | ) | const

| Returns true if a material has been assigned to the submesh, otherwise returns false.

void Ogre::SubMesh::removeLodLevels | ( | void |  | ) | `[protected]`

| Internal method for removing LOD data.

void Ogre::SubMesh::setMaterialName | ( | const String & | matName | ) |

| Sets the name of the Material which this SubMesh will use.

## Friends And Related Function Documentation

friend class Mesh `[friend]`

| Definition at line 53 of file OgreSubMesh.h.

friend class MeshSerializerImpl `[friend]`

| Definition at line 54 of file OgreSubMesh.h.

friend class MeshSerializerImpl_v1_1 `[friend]`

| Definition at line 56 of file OgreSubMesh.h.

friend class MeshSerializerImpl_v1_2 `[friend]`

| Definition at line 55 of file OgreSubMesh.h.

## Member Data Documentation

IndexData* Ogre::SubMesh::indexData

| Face index data. Definition at line 78 of file OgreSubMesh.h.

VertexBoneAssignmentList Ogre::SubMesh::mBoneAssignments `[protected]`

| Definition at line 143 of file OgreSubMesh.h.

bool Ogre::SubMesh::mBoneAssignmentsOutOfDate `[protected]`

| Flag indicating that bone assignments need to be recompiled. Definition at line 146 of file OgreSubMesh.h.

ProgressiveMesh::LODFaceList Ogre::SubMesh::mLodFaceList

| Definition at line 80 of file OgreSubMesh.h.

String Ogre::SubMesh::mMaterialName `[protected]`

| Name of the material this SubMesh uses. Definition at line 137 of file OgreSubMesh.h.

bool Ogre::SubMesh::mMatInitialised `[protected]`

| Is there a material yet? Definition at line 140 of file OgreSubMesh.h.

RenderOperation::OperationType Ogre::SubMesh::operationType

| The render operation type used to render this submesh. Definition at line 66 of file OgreSubMesh.h.

Mesh* Ogre::SubMesh::parent

| Reference to parent Mesh (not a smart pointer so child does not keep parent alive). Definition at line 83 of file OgreSubMesh.h.

bool Ogre::SubMesh::useSharedVertices

| Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices. Definition at line 63 of file OgreSubMesh.h.

VertexData* Ogre::SubMesh::vertexData

Dedicated vertex data (only valid if useSharedVertices = false).

Remarks:
  This data is completely owned by this submesh.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

Definition at line 75 of file OgreSubMesh.h.

The documentation for this class was generated from the following file:

- OgreSubMesh.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:40:34 2005